    import { select, json, geoPath, 
             geoMercator, geoNaturalEarth1,
           	 geoOrthographic, tsv, zoom, event,
           	 scaleOrdinal, 
             schemeCategory10, schemeSet3, 
             schemeRdYlGn, schemeSpectral,
             schemeGreens, interpolateTurbo,
             interpolate } 
    from 'd3';

    import { feature } from "topojson";

    const width = document.body.clientWidth;
    const height = document.body.clientHeight;

    //console.log(height);

		const svg = select('svg')
    	.attr('width', width)
		  .attr('height', height);
    
    const config = {
    	speed: 0.0015,
   	 	verticalTilt: -10,
    	horizontalTilt: -0
    }
   
     
		// globe
    const projection = d3.geoOrthographic(); 
		// 2D cropped 
    // const projection = geoMercator();					
		// 2D large 
    //const projection = d3.geoNaturalEarth1(); 


    const pathGenerator = geoPath().projection(projection);
		
	
		// define g
		const g = svg.append('g');
		
		// Afghanistan??
		// globe 
		g.append('path')
    	.attr('class', 'sphere')
		  .attr('d', pathGenerator({type: 'Sphere'}));


		// zoom
    g.call(zoom().on('zoom', () => {
      g.attr('transform', event.transform);
    })); 

	  

		// load tsv and json data
		Promise.all([
      //tsv('https://unpkg.com/world-atlas@1.1.4/world/110m.tsv'),
   		tsv('110m.tsv'),
      //json('https://unpkg.com/world-atlas@1.1.4/world/110m.json')
      json('110m.json')
    ]).then(([tsvData, topoJSONData]) => {
      
      	//console.log(topoJSONData);
        //console.log(tsvData);
      
      	// row data by id from tsv
      	const tsvRow = {};
      	tsvData.forEach(d => {
        		tsvRow[d.iso_n3] = d; 	
        });
      	
      	/*
      	const tsvRow = tsvData.reduce((accumulator, d) => {
        		accumulator[d.iso_n3] = d;
        		return accumulator;
     		 }, {});
      	*/
        // geodata
        const countries = feature(topoJSONData, topoJSONData.objects.countries);  
        
      	countries.features.forEach(d => {
          Object.assign(d.properties, tsvRow[d.id]);
        });
      	
			//const colorScale = scaleOrdinal();
      //const colorScale = scaleOrdinal(schemeRdYlGn[3]);
        const colorScale = d3.scaleOrdinal(d3.schemeGreens[3]);
      //schemeRdYlGn[3] //schemeGreens[3] 
      
     	//const colorValue = d => d.properties.pop_est;
      //const colorValue = d => d.properties.economy;
      	
      
      /*colorScale
        .domain(countries.features.map(colorValue))
        .domain(colorScale.domain().sort()); //.reverse()
      //.domain(colorScale.domain().sort(function(a, b) { return a - b }));
      */
      //sorted Array 
      	const length = colorScale.domain().length;
      
      //var i = d3.interpolateNumber(0, 6);
      
      	var norm = function(val, max, min) { 
          var n = (val - min) / (max - min);
          if (n === undefined) {n = 1;} 
          return n;
        }
        
        console.log('74/' + length);
      	console.log(norm(74, length, 0));
      

      //colorScale.range(schemeSpectral[175]);
      //colorScale.range(schemeGreens[3]);
		  //colorScale.range(schemeSpectral[colorScale.domain().length]);
      //colorScale.range(schemeGreens[colorScale.domain().length]);
      
      //d3.schemeSpectral[norm(d)]
				const e = norm(20, 150, 0);
        console.log(e);
        console.log(d3.interpolateSpectral(e));

      	var colour = function(d) { 
          var col = norm(d);
          
          col = d3.interpolateSpectral(col);
          return col;
        }    
        
        console.log(colour(120));
      
      //append shapes
        g.selectAll('path').data(countries.features)
        .enter().append('path')
        .attr('class', 'country')
        .attr('d', pathGenerator)
     // .attr('fill', d => colorScale(colorValue(d)) ) // d => colorScale(colorValue(d))
        .attr('fill', d => colorScale(d.properties.name))
        .append('title')
        .text(d => d.properties.admin);
     	//.name // .iso_n3 // .sovereignt // .admin
    });



		enableRotation();

		const geopath = d3.geoPath().projection(projection);

    function enableRotation() {
        d3.timer(function (elapsed) {
            projection.rotate([config.speed * elapsed - 90, 
                               config.verticalTilt, config.horizontalTilt]);
            g.selectAll('.country').attr("d", geopath);
        });
    }  
	 

   

    

/*

		// data source
    json('https://unpkg.com/world-atlas@1.1.4/world/110m.json')
        .then(data => {
            const countries = feature(data, data.objects.countries);
      			//console.log(countries);
            svg.selectAll('path').data(countries.features)
                .enter().append('path')
         				.attr('class', 'country')
                .attr('d', pathGenerator)
      					.append('title')
      					//.text(d => console.log('aloha'));
      
      }); 
      
*/